﻿$("input[data-type='currency']").on({
    keyup: function () {
        formatCurrency($(this));
    },
    blur: function () {
        formatCurrency($(this), "blur");
    }
});
function formatNumber(n) {
    // format number 1000000 to 1,234,567
    return n.replace(/\D/g, "").replace(/\B(?=(\d{3})+(?!\d))/g, ",")
}

function formatCurrency(input, blur) {
    // appends $ to value, validates decimal side
    // and puts cursor back in right position.

    // get input value
    var input_val = input.val();

    // don't validate empty input
    if (input_val === "") { return; }

    // original length
    var original_len = input_val.length;

    // initial caret position 
    var caret_pos = input.prop("selectionStart");

    // check for decimal
    if (input_val.indexOf(".") >= 0) {

        // get position of first decimal
        // this prevents multiple decimals from
        // being entered
        var decimal_pos = input_val.indexOf(".");

        // split number by decimal point
        var left_side = input_val.substring(0, decimal_pos);
        var right_side = input_val.substring(decimal_pos);

        // add commas to left side of number
        left_side = formatNumber(left_side);

        // validate right side
        right_side = formatNumber(right_side);

        // On blur make sure 2 numbers after decimal
        if (blur === "blur") {
            right_side += "00";
        }

        // Limit decimal to only 2 digits
        right_side = right_side.substring(0, 2);

        // join number by .
        //input_val = "$" + left_side + "." + right_side;
        input_val = left_side;

    } else {
        // no decimal entered
        // add commas to number
        // remove all non-digits
        input_val = formatNumber(input_val);
        //input_val = "$" + input_val;
        input_val = input_val;

        // final formatting
        if (blur === "blur") {
            //input_val += ".00";
            input_val;
        }
    }

    // send updated string to input
    input.val(input_val);

    // put caret back in the right position
    var updated_len = input_val.length;
    caret_pos = updated_len - original_len + caret_pos;
    input[0].setSelectionRange(caret_pos, caret_pos);
}

//########### Login_Text_Effect ########################
function load_for_login() {
    Array.from(document.querySelectorAll('.floating-label input, .floating-label textarea'))
        .forEach(i => i.addEventListener('keyup', handle_input_value));

    document.addEventListener('load', () => {
        Array.from(document.querySelectorAll('.floating-label input, .floating-label textarea'))
            .forEach(i => { if (i.value) i.classList.add('has-value'); });
    })
}

function handle_input_value(e) {
    if (e.target.value) e.target.classList.add('has-value');
    else e.target.classList.remove('has-value');
}
//########### /Login_Text_Effect ########################


function openNav() {
    document.getElementById("mySidebar").style.right = "0px";
}

function closeNav() {
    if (document.getElementById("myNav").classList.contains('show')) {

        document.getElementById("mySidebar").style.right = "-300px";
    }
}

//########### Sidebar_Admin ########################
function toggle_Sidebar() {
    var sidebar = document.querySelector('.sidebar')
    var menu = document.querySelector('.menu')
    var content = document.querySelectorAll('.fill-main-content')

    if (menu.classList.contains('opened')) {
        sidebar.style.width = "0"
        sidebar.style.overflow = "hidden"
        sidebar.classList.remove('px-2')

        content.forEach(item => {
            item.classList.add('open-content')
        })
    } else {
        sidebar.style.width = "300px"
        sidebar.style.overflow = "auto"
        sidebar.classList.add('px-2')

        content.forEach(item => {
            item.classList.remove('open-content')
        })
    }
}
//########### /Sidebar_Admin ########################

//########### Sidebar_Client ########################
function toggle_sidebar() {
    var sidebar = document.querySelector(".my-sidebar")
    sidebar.classList.add('open-sidebar')
}

function close_sidebar(el) {
    var sidebar = document.querySelector(".my-sidebar")
    el.addEventListener('click', (e) => {
        var outside = !sidebar.contains(e.target)

        if (outside && sidebar.classList.contains('open-sidebar')) {
            sidebar.classList.remove('open-sidebar')
        }
    })
}
//########### /Sidebar_Client ########################


window.onFocus = (id) => {
    var currInput = document.activeElement;
    if (currInput.tagName.toLowerCase() == "input") {
        var inputs = document.querySelectorAll("input,select");
        for (var i = 0; i < inputs.length; i++) {
            if (inputs[i] == currInput) {
                var next = inputs[i + 1];
                if (next && next.focus) {
                    next.focus();
                }
                break;
            }
        }
    }
}

(function () {

    window.saveFile = function (bytesBase64, mimeType, fileName) {
        var fileUrl = "data:" + mimeType + ";base64," + bytesBase64;
        fetch(fileUrl)
            .then(response => response.blob())
            .then(blob => {
                var link = window.document.createElement("a");
                link.href = window.URL.createObjectURL(blob, { type: mimeType });
                link.download = fileName;
                document.body.appendChild(link);
                link.click();
                document.body.removeChild(link);
            });
    }
})();

(function () {
    window.blazorOpen = (_url, caption, _windowoption) => {
        var left = (screen.width - 1000) / 2;
        let xWindow = window.open(_url, caption, _windowoption + ',left=' + left);
        if (!xWindow) return false;
    };
})();


function openWindowWithPost(url, data) {
    var form = document.createElement("form");
    form.target = "_blank";
    form.method = "POST";
    form.action = url;
    form.style.display = "none";

    var input = document.createElement("input");
    input.type = "hidden";
    input.name = 'id';
    input.value = data;
    form.appendChild(input);

    document.body.appendChild(form);
    form.submit();
    document.body.removeChild(form);
}
async function Z_GridScroll() {
    var gdata = document.getElementsByClassName('rz-data-grid-data');
    if (gdata == null) return;
    if (gdata.length == 0) return;
    gdata[0].scrollLeft = 20000;
}

async function Z_ChatScroll() {
    var gdata = document.getElementsByClassName('Chat_Body');
    if (gdata == null) return;
    if (gdata.length == 0) return;
    gdata[0].scrollTop = 20000;
}

window.Z_Picture = {
    AddHandler: function (addressProvider, Z_Name, maxWidth, maxHeight, quality) {
        const inp1 = document.getElementById(Z_Name);
        if (inp1 != null) {
            var myevent;
            inp1.addEventListener('change', myevent = async (e) => {
                if (e == null) return;
                if (e.target == null) return;
                if (e.target.files[0] == null) return;
                let img = e.target.files[0];
                const reader = new FileReader();
                reader.readAsDataURL(e.target.files[0]);
                reader.onload = async event => {
                    let imgCompressed = await CompressImage(event.target.result, maxWidth, maxHeight, quality) // set to 75%
                    let compSize = atob(imgCompressed.split(",")[1]).length;
                    addressProvider.invokeMethodAsync("ChangeImage", img.name, compSize, imgCompressed.split(",")[1]).then((data) => {

                    });
                };
            });
        }
    }
};
document.addEventListener('DOMContentLoaded', function (e) {
    document.body.addEventListener('keydown', function (e) {
        if (e.keyCode == 116) {
            if (confirm("مایل به بازخوانی سامانه هستید؟ از ذخیره بودن اطلاعات مطمئن شوید")) {
                window.location.href = "/"
            } else {
                e.preventDefault();
            }
        }
    }, false);
}, false);

window.onbeforeunload = function () { return "با این کار ممکن است اطلاعات شما مخدوش شود"; }

async function CompressImage(filebyte, maxWidth, maxHeight, quality) {
    return new Promise((resolve, reject) => {
        const img = new Image();
        img.src = filebyte;
        img.onload = () => {
            let width = img.width;
            let height = img.height;

            if (width > height) {
                if (width > maxWidth) {
                    height *= maxWidth / width;
                    width = maxWidth;
                }
            } else {
                if (height > maxHeight) {
                    width *= maxHeight / height;
                    height = maxHeight;
                }
            }

            const canvas = document.createElement('canvas');
            canvas.width = width;
            canvas.height = height;
            const ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0, width, height);
            const base64String = canvas.toDataURL('image/jpeg', quality);
            resolve(base64String);
        };
        onerror = error => reject(error);
    });
}

(function () {
    window.blazorPushNotifications = {
        requestSubscription: async (applicationServerPublicKey) => {
            const worker = await navigator.serviceWorker.getRegistration();
            if (!worker) {
                navigator.serviceWorker.register('/service-worker.js');
                worker = await navigator.serviceWorker.getRegistration();
            }
            const existingSubscription = await worker.pushManager.getSubscription();
            if (!existingSubscription) {
                const newSubscription = await subscribe(worker, applicationServerPublicKey);
                if (newSubscription) {
                    return {
                        url: newSubscription.endpoint,
                        p256dh: arrayBufferToBase64(newSubscription.getKey('p256dh')),
                        auth: arrayBufferToBase64(newSubscription.getKey('auth'))
                    };
                }
            } else {
                return {
                    url: existingSubscription.endpoint,
                    p256dh: arrayBufferToBase64(existingSubscription.getKey('p256dh')),
                    auth: arrayBufferToBase64(existingSubscription.getKey('auth'))
                };
            }
        }
    };

    async function subscribe(worker, applicationServerPublicKey) {
        try {
            return await worker.pushManager.subscribe({
                userVisibleOnly: true,
                applicationServerKey: applicationServerPublicKey
            });
        } catch (error) {
            if (error.name === 'NotAllowedError') {
                return null;
            }
            throw error;
        }
    }

    function arrayBufferToBase64(buffer) {
        var binary = '';
        var bytes = new Uint8Array(buffer);
        var len = bytes.byteLength;
        for (var i = 0; i < len; i++) {
            binary += String.fromCharCode(bytes[i]);
        }
        return window.btoa(binary);
    }
})();
